# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from baxter_core_msgs/EndEffectorState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class EndEffectorState(genpy.Message):
  _md5sum = "ade777f069d738595bc19e246b8ec7a0"
  _type = "baxter_core_msgs/EndEffectorState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#
time timestamp              # time when state was updated
uint32 id                   # EndEffectorId
#
# The following State fields are tristate: 0 = false; 1 = true; 2 = unknown/unsupported
  uint8   STATE_FALSE = 0
  uint8   STATE_TRUE = 1
  uint8   STATE_UNKNOWN = 2
#
uint8   enabled             # true if enabled
uint8   calibrated          # true if calibration has completed
uint8   ready               # true if ready for another command
uint8   moving              # true if moving
uint8   gripping            # true if gripping
uint8   missed              # true if GRIP/GOTO/SET was commanded and the gripper reaches the end of travel
uint8   error               # true if the gripper is in an error state
uint8   reverse             # true if the gripper is in reverse mode
#
float32 position            # position as a percentage of the max position;      0=closed - 100=open
#
  float32 POSITION_CLOSED = 0.0
  float32 POSITION_OPEN   = 100.0
#
float32 force               # force as a percentage of max force;                0=none   - 100=max
#
  float32 FORCE_MIN = 0.0
  float32 FORCE_MAX = 100.0
#
string state                # JSON: other state information
#
string command              # from the last command message
string command_sender
uint32 command_sequence
#
"""
  # Pseudo-constants
  STATE_FALSE = 0
  STATE_TRUE = 1
  STATE_UNKNOWN = 2
  POSITION_CLOSED = 0.0
  POSITION_OPEN = 100.0
  FORCE_MIN = 0.0
  FORCE_MAX = 100.0

  __slots__ = ['timestamp','id','enabled','calibrated','ready','moving','gripping','missed','error','reverse','position','force','state','command','command_sender','command_sequence']
  _slot_types = ['time','uint32','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','float32','float32','string','string','string','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,id,enabled,calibrated,ready,moving,gripping,missed,error,reverse,position,force,state,command,command_sender,command_sequence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EndEffectorState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.id is None:
        self.id = 0
      if self.enabled is None:
        self.enabled = 0
      if self.calibrated is None:
        self.calibrated = 0
      if self.ready is None:
        self.ready = 0
      if self.moving is None:
        self.moving = 0
      if self.gripping is None:
        self.gripping = 0
      if self.missed is None:
        self.missed = 0
      if self.error is None:
        self.error = 0
      if self.reverse is None:
        self.reverse = 0
      if self.position is None:
        self.position = 0.
      if self.force is None:
        self.force = 0.
      if self.state is None:
        self.state = ''
      if self.command is None:
        self.command = ''
      if self.command_sender is None:
        self.command_sender = ''
      if self.command_sequence is None:
        self.command_sequence = 0
    else:
      self.timestamp = genpy.Time()
      self.id = 0
      self.enabled = 0
      self.calibrated = 0
      self.ready = 0
      self.moving = 0
      self.gripping = 0
      self.missed = 0
      self.error = 0
      self.reverse = 0
      self.position = 0.
      self.force = 0.
      self.state = ''
      self.command = ''
      self.command_sender = ''
      self.command_sequence = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I8B2f.pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.id, _x.enabled, _x.calibrated, _x.ready, _x.moving, _x.gripping, _x.missed, _x.error, _x.reverse, _x.position, _x.force))
      _x = self.state
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.command
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.command_sender
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_I.pack(self.command_sequence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 28
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.id, _x.enabled, _x.calibrated, _x.ready, _x.moving, _x.gripping, _x.missed, _x.error, _x.reverse, _x.position, _x.force,) = _struct_3I8B2f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.state = str[start:end].decode('utf-8')
      else:
        self.state = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command = str[start:end].decode('utf-8')
      else:
        self.command = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command_sender = str[start:end].decode('utf-8')
      else:
        self.command_sender = str[start:end]
      start = end
      end += 4
      (self.command_sequence,) = _struct_I.unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I8B2f.pack(_x.timestamp.secs, _x.timestamp.nsecs, _x.id, _x.enabled, _x.calibrated, _x.ready, _x.moving, _x.gripping, _x.missed, _x.error, _x.reverse, _x.position, _x.force))
      _x = self.state
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.command
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.command_sender
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_I.pack(self.command_sequence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 28
      (_x.timestamp.secs, _x.timestamp.nsecs, _x.id, _x.enabled, _x.calibrated, _x.ready, _x.moving, _x.gripping, _x.missed, _x.error, _x.reverse, _x.position, _x.force,) = _struct_3I8B2f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.state = str[start:end].decode('utf-8')
      else:
        self.state = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command = str[start:end].decode('utf-8')
      else:
        self.command = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command_sender = str[start:end].decode('utf-8')
      else:
        self.command_sender = str[start:end]
      start = end
      end += 4
      (self.command_sequence,) = _struct_I.unpack(str[start:end])
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I8B2f = struct.Struct("<3I8B2f")
